//+------------------------------------------------------------------+
//|                                                Nature BETA 2.mq4 |
//|                                    Copyright  2007, Ryan Klefas |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Ryan Klefas (Base 1.8)"
#property link      "rklefas@inbox.com"


extern string    basic="==== Basic Settings ====================";
extern int       TakeProfit=50;
extern int       Stoploss=25;
extern double    Lots=0.1;

extern string    autolot="==== Automatic Lots ====================";
extern bool      Fibonacci = true;
extern double    MaxAllowedLotSize = 50;        // User specified maximum Lot Size for orders

extern string    manage="==== Stop Management ====================";
extern int       BreakEvenAt=0;                 // Set Stoploss to open order price at X pips profit
extern int       BreakEvenSlide=0;              // Move the breakeven point up or down around
                                                      //     the order open price
extern int       TrailingStop=0;                // Stoploss follows behind current price by X pips
extern bool      OnlyTrailAfterProfit=false;    // Trailing Stop will only trail when order is profitable

extern string    order="==== Order Settings ====================";
extern bool      Disable_LongTrades=false;      // Long order creating section of the EA will not run
extern bool      Disable_ShortTrades=false;     // Short order creating section of the EA will not run
       bool      Disable_ClosingLong=true;      // Long order closing section of the EA will not run
       bool      Disable_ClosingShort=true;     // Short order closing section of the EA will not run
       int       MaximumOrders=3;               // Maximum number of orders allowed per pair 

extern string    account="==== Account Settings ====================";
extern int       MinimumEquity=0;               // New orders will be disabled if equity drops below minimum
extern int       MinimumBalance=0;              // New orders will be disabled if balance drops below minimum

extern string    id="==== Identity Settings ====================";
extern string    ExpertName="Nature BETA 2";    // Expert name: for aesthetic purposes
extern int       ExpertID=21354;                // Magic number: for identifying the EA's orders
extern bool      Disable_Comments=false;        // EA will not display comments on screen



int slv;
int tpv;


//+------------------------------------------------------------------+
//| global variables                                              |
//+------------------------------------------------------------------+

       // Individual order types

   int longActive=0,  shortActive=0;
   int longStop=0,    shortStop=0;
   int longLimit=0,   shortLimit=0;
   
       // Accumulative order types
   
   int longPending=0, shortPending=0;
   int allLong=0,     allShort=0;
   int allActive=0,   allPending=0;
   int grandTotal=0;   
   
   int grandTotal_HISTORIC = 0;
   

   int historyPosition[1];
   int historyWinLoss[1];
   double historyLotSize[1];


   
       // Order taking permission

   bool disabledByCalculation_Longs=false; 
   bool disabledByCalculation_Shorts=false;


       // Spreads calculated in the houseKeeper() function

   double spread_dub=0;
   
   
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   onScreenComment(91);
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   onScreenComment(99);
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   houseKeeper();
 //  onScreenComment(98);

//+------------------------------------------------------------------+
//| variable and indicator declaration                               |
//+------------------------------------------------------------------+



double lastStopRel, lastTPRel;

if (grandTotal_HISTORIC==0)
{   
   slv=Stoploss;
   tpv=TakeProfit;
}

if (historyWinLoss[0]==(-2))
{
   OrderSelect(historyPosition[0], SELECT_BY_POS, MODE_HISTORY);
   
   
   if (lastOrderType()==1)
   {
      lastTPRel   = (OrderTakeProfit()-OrderOpenPrice())/Point;
      lastStopRel = (OrderOpenPrice()-OrderStopLoss())/Point;
   }
   if (lastOrderType()==(-1))
   {
      lastStopRel = (OrderStopLoss()-OrderOpenPrice())/Point;
      lastTPRel   = (OrderOpenPrice()-OrderTakeProfit())/Point;
   
   }   
   slv=lastStopRel;
   tpv=lastTPRel;

Comment(lastStopRel, lastTPRel);
}
else
{   
   slv=Stoploss;
   tpv=TakeProfit;
}





//+------------------------------------------------------------------+
//| close existing long orders under apprpriate conditions           |
//+------------------------------------------------------------------+
   if (Disable_ClosingLong==false && allLong>0)  {
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+





   // CODE FOR CLOSING EXISTING LONG ORDERS






//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
      }
//+------------------------------------------------------------------+
//| close existing short orders under apprpriate conditions          |
//+------------------------------------------------------------------+
   if (Disable_ClosingShort==false && allShort>0)  {
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+





   // CODE FOR CLOSING EXISTING SHORT ORDERS


    
      
      
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
      }
//+------------------------------------------------------------------+
//| create new long orders                                                |
//+------------------------------------------------------------------+
   if (newOrderPermitted(1))  {
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+


   findMyOrders();



   if (allActive==0)
   {
      if (lastOrderType()==(-1) && historyWinLoss[0]==(-2))
         sendLongOrder();
      if (lastOrderType()==0)
         sendLongOrder();
      if (lastOrderType()==(1) && historyWinLoss[0]==(2))
         sendLongOrder();
   }





//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
      }
//+------------------------------------------------------------------+
//| create new short orders                                          |
//+------------------------------------------------------------------+
   if (newOrderPermitted(2))  {
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+




   findMyOrders();


   if (allActive==0)
   {
      if (lastOrderType()==(1) && historyWinLoss[0]==(-2))
         sendShortOrder();
      if (lastOrderType()==0)
         sendShortOrder();
      if (lastOrderType()==(-1) && historyWinLoss[0]==(2))
         sendShortOrder();
   }



//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

      }
   return(0);  // End of start function
}
  
//+------------------------------------------------------------------+
//| middle-man modules                                               |
//+------------------------------------------------------------------+

void sendLongOrder() // Base Version 1.8
{ versatileOrderTaker(1, -1, Ask); }
   
//+------------------------------------------------------------------+

void sendShortOrder() // Base Version 1.8
{ versatileOrderTaker(2, -1, Bid); }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| standardized modules and functions                               |
//+------------------------------------------------------------------+

void onScreenComment(int event) // Base Version 1.8
{

   if (Disable_Comments==false)
   {
      
      string bal = DoubleToStr(AccountBalance(), 2);
      string eq  = DoubleToStr(AccountEquity(), 2);
      
      string header = ExpertName + " is running.";
      string status = "\n\n" + 
                      "Orders / Maximum Allowed:  " + grandTotal + " / " + MaximumOrders 
                      + "\n" + 
                      "Minimum Equity / Actual:  " + MinimumEquity + " / " + eq 
                      + "\n" + 
                      "Minimum Balance / Actual:  " + MinimumBalance + " / " + bal
                      + "\n" 
                      + "\n\n" 
                      ;
                      
      
      switch (event)
      {

         case 91: Comment(ExpertName + " is waiting for the next tick to begin."); break;
         case 98: Comment(header + status); break;
         
         case 99: Comment(" "); break;

         case 11: Comment(header + status + "New Orders Disabled:  User option");  break;
         case 12: Comment(header + status + "New Orders Disabled:  Internal calculation"); break;
         case 13: Comment(header + status + "New Orders Disabled:  Equity below minumum"); break;
         case 14: Comment(header + status + "New Orders Disabled:  Balance below minimum"); break;
         case 15: Comment(header + status + "New Orders Disabled:  Existing orders at maximum"); break;

         case 21: Comment(header + status + "New Long Orders Disabled:  User option");  break;
         case 22: Comment(header + status + "New Long Orders Disabled:  Internal calculation"); break;

         case 31: Comment(header + status + "New Short Orders Disabled:  User option"); break;
         case 32: Comment(header + status + "New Short Orders Disabled:  Internal calculation"); break;

      }
   }

}

//+------------------------------------------------------------------+

void houseKeeper() // Base Version 1.8
{

   // Reset all global variables for the next run through

   longActive=0;  shortActive=0;
   longStop=0;    shortStop=0;
   longLimit=0;   shortLimit=0;
   longPending=0; shortPending=0;
   allLong=0;     allShort=0;
   allActive=0;   allPending=0;
   grandTotal=0;   
   
   disabledByCalculation_Longs=false;      
   disabledByCalculation_Shorts=false;

   spread_dub = (Ask-Bid);

   // Call important startup functions

   findMyOrders();
   findMyOrders_HISTORIC();
   historyLogger();

   if (allActive>0)
   {
      if (BreakEvenAt>0)
         breakEvenManager();
      if (TrailingStop>0)
         trailingStopManager();
   }
   
}

//+------------------------------------------------------------------+

int simpleMagicGenerator() 
{
   return (ExpertID);
}

//+------------------------------------------------------------------+

bool orderBelongsToMe() // Base Version 1.8
{
   if (OrderSymbol()==Symbol() && OrderMagicNumber()==simpleMagicGenerator() )
       return (true);
   else
      return (false);
}

//+------------------------------------------------------------------+

void findMyOrders() // Base Version 1.8
{

   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if ( orderBelongsToMe() )
      {  
         if (OrderType()==OP_BUY)
            {longActive++;}
         else if (OrderType()==OP_SELL)
            {shortActive++;}
         else if (OrderType()==OP_BUYSTOP)
            {longStop++;}
         else if (OrderType()==OP_SELLSTOP)
            {shortStop++;}
         else if (OrderType()==OP_BUYLIMIT)
            {longLimit++;}
         else if (OrderType()==OP_SELLLIMIT)
            {shortLimit++;}
      }
   }


   longPending  = longStop + longLimit;
   shortPending = shortStop + shortLimit;
   allPending   = longPending + shortPending;
   allActive    = longActive + shortActive;
   allLong      = longStop + longLimit + longActive;
   allShort     = shortStop + shortLimit + shortActive;
   grandTotal   = allActive + allPending;

   
}

//+------------------------------------------------------------------+

void findMyOrders_HISTORIC() 
{

   grandTotal_HISTORIC = 0;

   int orderMethod=0;
   int orderMode=1;
   int startingOrder=0;
   int endingOrder=OrdersHistoryTotal(); 


   if (OrdersHistoryTotal()>0)
   {
      for(int selectedOrder=startingOrder; selectedOrder<endingOrder; selectedOrder++)
      {
         OrderSelect(selectedOrder, orderMethod, orderMode);
   
         if ( orderBelongsToMe() )
         {
            grandTotal_HISTORIC++;
         }
      }

   }


}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

bool newOrderPermitted(int simpleOrderType) // Base Version 1.8
{

   if (Disable_LongTrades && Disable_ShortTrades)
      { onScreenComment(11); return (false); }
   else if (disabledByCalculation_Longs && disabledByCalculation_Shorts)
      { onScreenComment(12); return (false); }
   else if (AccountEquity()<MinimumEquity)
      { onScreenComment(13); return (false);}
   else if (AccountBalance()<MinimumBalance)
      { onScreenComment(14); return (false);}
   else if (grandTotal>=MaximumOrders)
      { onScreenComment(15); return (false);}


   if (simpleOrderType==1)
   {
      if (Disable_LongTrades)
         { onScreenComment(21); return (false); }
      else if (disabledByCalculation_Longs)
         { onScreenComment(22); return (false); }
      else
         return (true);
   }
   else if (simpleOrderType==2)
   {
      if (Disable_ShortTrades)
         { onScreenComment(31); return (false); }
      else if (disabledByCalculation_Shorts)
         { onScreenComment(32); return (false); }
      else
         return (true);
   }
}

//+------------------------------------------------------------------+

double lotMaker() 
{


   double finalLot=Lots;
   
   if (grandTotal_HISTORIC>0)
   {
      if (Fibonacci)
         finalLot = FiboLots();
   }   

   if (finalLot<=0)
      finalLot=0.1;

   if (finalLot>MaxAllowedLotSize)
      finalLot=MaxAllowedLotSize;

   if (finalLot>100)
      finalLot=100;
   
   return (finalLot);

}

//+------------------------------------------------------------------+

void breakEvenManager() // Base Version 1.8
{

   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if (BreakEvenAt>0 && orderBelongsToMe())
      {
         if (OrderType()==OP_BUY)
         {
            if (Bid-OrderOpenPrice()>=Point*BreakEvenAt)
            {
               if (OrderStopLoss()<OrderOpenPrice() + BreakEvenSlide*Point)
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice() + BreakEvenSlide*Point,OrderTakeProfit(),0,Green); 
            }
         }
         else if (OrderType()==OP_SELL)
         {
            if (OrderOpenPrice()-Ask>=Point*BreakEvenAt)
            {
               if (OrderStopLoss()>OrderOpenPrice() - BreakEvenSlide*Point)
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice() - BreakEvenSlide*Point,OrderTakeProfit(),0,Red); 
            }
         }
      }
   }


}
   
//+------------------------------------------------------------------+

void trailingStopManager() // Base Version 1.8
{
   
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if (TrailingStop>0 && orderBelongsToMe())
      {
         if (OrderType()==OP_BUY)
         {
            if ((Bid-OrderOpenPrice()>Point*TrailingStop) || OnlyTrailAfterProfit==false)
            {
               if (OrderStopLoss()<Bid-Point*TrailingStop)
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green); 
            }
         }
         else if (OrderType()==OP_SELL)
         {
            if ((OrderOpenPrice()-Ask>Point*TrailingStop) || OnlyTrailAfterProfit==false)
            {
               if ((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red); 
            }
         }
      }  
   }

}

//+------------------------------------------------------------------+

string commentString()
{
   return (ExpertName);
}

//+------------------------------------------------------------------+

void versatileOrderTaker(int simpleType, int forcedLotSize, double entryPrice) // Base Version 1.8
{

   // Variable calculations

   double Stopvalue=0, TPvalue=0, orderLotSize=0;
   int slippage=3, expiration=0;
   int ticket, oType;
   string typeName;
   
   if (forcedLotSize<0)
      orderLotSize=lotMaker();
   else
      orderLotSize=forcedLotSize;


   switch (simpleType)
   {
      case 4: 
      if (entryPrice<Bid)  { oType=OP_SELLSTOP;  typeName="SELLSTOP"; }
      if (entryPrice>Bid)  { oType=OP_SELLLIMIT; typeName="SELLLIMIT"; }
      if (Stoploss>0)      { Stopvalue = entryPrice+spread_dub+Stoploss*Point; }
      if (TakeProfit>0)    { TPvalue   = entryPrice-TakeProfit*Point; }
      break;
         
      case 3:
      if (entryPrice>Ask)  { oType=OP_BUYSTOP;  typeName="BUYSTOP"; }
      if (entryPrice<Ask)  { oType=OP_BUYLIMIT; typeName="BUYLIMIT"; }
      if (Stoploss>0)      { Stopvalue = entryPrice-spread_dub-Stoploss*Point; }
      if (TakeProfit>0)    { TPvalue   = entryPrice+TakeProfit*Point; }
      break;

      case 2:
      oType=OP_SELL; typeName="SELL"; entryPrice=Bid;
      if (Stoploss>0)      { Stopvalue = entryPrice+spread_dub+Stoploss*Point; }
      if (TakeProfit>0)    { TPvalue   = entryPrice-TakeProfit*Point; }
      break;

      case 1:
      oType=OP_BUY; typeName="BUY"; entryPrice=Ask;
      if (Stoploss>0)      { Stopvalue = entryPrice-spread_dub-Stoploss*Point; }
      if (TakeProfit>0)    { TPvalue   = entryPrice+TakeProfit*Point; }
      break;
      
      default:
      Print ("versatileOrderTaker has been passed an invalid SimpleType parameter: " + simpleType);
   }

   // Send Order using previously calculated variables
   
   ticket=OrderSend(Symbol(),oType,orderLotSize,entryPrice,slippage,Stopvalue,TPvalue,commentString(),simpleMagicGenerator(),expiration,Green);
   if (ticket>0)
     {if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(ExpertName + " " + typeName + " order at ",OrderOpenPrice()); }
   else 
      Print("Error opening " + typeName + " order: ",GetLastError());
}

//+------------------------------------------------------------------+
/*
void versatileOrderCloser(int simpleType) // Base Version 1.8
{
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      
      if ( orderBelongsToMe() )
      {
         switch (simpleType)
         {
            case 4:
            case 3:
               if (OrderType()>OP_SELL)   OrderDelete(OrderTicket());
            break;
         
            case 2:
               if (OrderType()==OP_SELL)  OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE); 
            break;
         
            case 1:
               if (OrderType()==OP_BUY)   OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE); 
            break;
         
            default:
            Print ("versatileOrderCloser has been passed an invalid SimpleType parameter: " + simpleType);
         }
      }
   }
}
*/

//+------------------------------------------------------------------+
//| customized modules and functions                                 |
//+------------------------------------------------------------------+

void historyLogger() 
{

   int cnt, positionCounter = grandTotal_HISTORIC-1;

//   if (positionCounter<0)
      positionCounter = 0;
      
      
   if (grandTotal_HISTORIC>0)
   {
      
      if (grandTotal_HISTORIC>1)
      {
         ArrayResize(historyPosition, grandTotal_HISTORIC);
         ArrayResize(historyLotSize, grandTotal_HISTORIC);
         ArrayResize(historyWinLoss, grandTotal_HISTORIC);
      }
      
      for(cnt = OrdersHistoryTotal()-1;cnt>=0;cnt--)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);

         if ( orderBelongsToMe() )
         {
            historyPosition[positionCounter] = cnt;
            historyLotSize[positionCounter] = OrderLots();

            if (OrderClosePrice() == OrderTakeProfit())
               historyWinLoss[positionCounter] = 2; 
            else if (OrderClosePrice() == OrderStopLoss())
               historyWinLoss[positionCounter] = -2;
            else if (OrderProfit() > 0)
               historyWinLoss[positionCounter] = 1; 
            else if (OrderProfit() < 0)
               historyWinLoss[positionCounter] = -1;
            else 
               historyWinLoss[positionCounter] = 0;
            
            positionCounter++;
         }
      }
   }

      string go;

      for(cnt = 0;cnt<grandTotal_HISTORIC;cnt++)
      {
         go = go + historyPosition[cnt] + " " + historyWinLoss[cnt] + " " + historyLotSize[cnt] + "\n";
      }
      
   //   Comment(grandTotal_HISTORIC + " " + go);
      
      
}


//+------------------------------------------------------------------+

double FiboLots() 
{

   int xx = 0;
/*   
   if (grandTotal_HISTORIC<2)
      return (Lots);
*/
   if (historyWinLoss[xx] == (-2) && historyWinLoss[xx+1] == (-2))
      return (historyLotSize[xx]+historyLotSize[xx+1]);
   else if (historyWinLoss[xx] == 0)
      return (historyLotSize[xx]);
   else 
      return (Lots);
      
}


//+------------------------------------------------------------------+

int lastOrderType()
{
   if (grandTotal_HISTORIC==0)
      return (0);
   else
   {
      OrderSelect(historyPosition[0], SELECT_BY_POS, MODE_HISTORY);

      if (OrderType()==OP_BUY)
         return (1);
      else if (OrderType()==OP_SELL)
         return (-1);
   }
}

//+------------------------------------------------------------------+


//+------------------------------------------------------------------+


